#ifdef HAVE_CONFIG_H
//#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "calculos.h"
#include "callbacks2.h"
#include "interface2.h"
#include "support.h"
#include "gtkdatabox.h"
#include "stdio.h"
#include "calculos.h"

gint tag;

gboolean
on_custom1_button_press_event          (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
handle_signal_motion_notify				(GtkDatabox *box,
										 GtkDataboxCoord *position)
{
  
  GtkTextBuffer *buffer;
  GtkDataboxValue *valor;
  char cadena[30];

	;
	
}


void
on_Exit_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{	
	gtk_main_quit();
}

void
on_Exit_graph_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{	
	general_param *pass_data;
	pass_data=(general_param*)user_data;
	g_source_remove(tag);
	gtk_widget_destroy(GTK_WIDGET(pass_data->current_window));
}


void
on_Exit_offline_graph_clicked                  (GtkButton       *button,
                                        		gpointer         user_data)
{	
	general_param *pass_data;
	pass_data=(general_param*)user_data;
	(*(pass_data->first_param)).clear();
	(*(pass_data->second_param)).clear();	
	pass_data->open_param_window=FALSE;
	gtk_widget_destroy(GTK_WIDGET(pass_data->current_window));
}






void
on_Open_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkTreeModel *model;
	GtkTreeIter iter;
	GtkWidget *view;
	GtkTreeSelection *selected_row;
	GtkWidget *widget;
	GtkWidget *sel_box1;
	GtkWidget *sel_box2;
	GtkWidget *lab1;
	GtkWidget *lab2;
	GtkWidget *lab3;
	GtkWidget *lab4;	
	GtkWidget *exit;
	int sel1;
	int sel2;
	general_param *pass_data;
	const char *labels[8]= {"RX Power", "Packets IN",  "Traffic IN", "Packets OUT", "Traffic OUT", "Retries", "Connection SPD",  "Total Traffic"};
	const char *units[8]= {"dB", "Packets/s",  "Bits/s", "Packets/s", "Bits/s", "Retries/s", "Mbits/s",  "Bits/s"};
	pass_data=(general_param*)user_data;
// generate an event to refresh the info in the graphs
// fdclient is the file descriptor to access the packet procesor server

if (pass_data->open_param_window==FALSE)
   	{
	   // find out which is the selected row
	   view=lookup_widget(GTK_WIDGET(pass_data->main_window),"treeview2");
	   selected_row=gtk_tree_view_get_selection(GTK_TREE_VIEW(view));
	   gtk_tree_selection_get_selected(selected_row,&model,&iter);
	   char *mac_string;
	   gtk_tree_model_get(model,&iter,MAC_ADDRESS,&mac_string,-1);
	   g_print("selected mac_address is %s\n",mac_string);
	   pass_data->mac_address_required=mac_string;
	   pass_data->current_window= create_window1 (pass_data);
		gtk_widget_show (pass_data->current_window);
	   sel_box1=lookup_widget(GTK_WIDGET(pass_data->main_window),"combobox1");
	   sel_box2=lookup_widget(GTK_WIDGET(pass_data->main_window),"combobox2");
	   sel1=gtk_combo_box_get_active(GTK_COMBO_BOX(sel_box1));
	   if(sel1!=-1)
			{
			pass_data->measure1=sel1;
			}
		else
			{
			pass_data->measure1=0;
			};
	   sel2=gtk_combo_box_get_active(GTK_COMBO_BOX(sel_box2));
	   if(sel2!=-1)
			{
			pass_data->measure2=sel2;
			}
		else
			{
			pass_data->measure2=0;
			};
	    lab1=lookup_widget(GTK_WIDGET(pass_data->current_window),"label1");
		lab2=lookup_widget(GTK_WIDGET(pass_data->current_window),"label2");
		lab3=lookup_widget(GTK_WIDGET(pass_data->current_window),"label_unit_1");
		lab4=lookup_widget(GTK_WIDGET(pass_data->current_window),"label_unit_2");				
		exit=lookup_widget(GTK_WIDGET(pass_data->current_window),"Exit");		
		gtk_label_set_text(GTK_LABEL(lab1),labels[pass_data->measure1]);
        gtk_label_set_text(GTK_LABEL(lab2),labels[pass_data->measure2]);
		gtk_label_set_text(GTK_LABEL(lab3),units[pass_data->measure1]);
        gtk_label_set_text(GTK_LABEL(lab4),units[pass_data->measure2]);	
	    tag=gtk_timeout_add (500,(GtkFunction)refresh_graph,(void*)pass_data);
		pass_data->open_param_window=TRUE;			
		}
}














void
on_Offline_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkTreeModel *model;
	GtkTreeIter iter;
	GtkWidget *view;
	GtkTreeSelection *selected_row;
	GtkWidget *widget;
	GtkWidget *sel_box1;
	GtkWidget *sel_box2;
	GtkWidget *lab1;
	GtkWidget *lab2;
	GtkWidget *lab3;
	GtkWidget *lab4;	
	GtkWidget *exit;
    GtkWidget *dialog;	
	int sel1;
	int sel2;
	FILE *fdes;
	general_param *pass_data;
	const char *labels[8]= {"RX Power", "Packets IN",  "Traffic IN", "Packets OUT", "Traffic OUT", "Retries", "Connection SPD",  "Total Traffic"};
	const char *units[8]= {"dB", "Packets/s",  "Bits/s", "Packets/s", "Bits/s", "Retries/s", "Mbits/s",  "Bits/s"};
	pass_data=(general_param*)user_data;

	dialog = gtk_file_chooser_dialog_new ("Open File",
				      GTK_WINDOW(pass_data->main_window),
				      GTK_FILE_CHOOSER_ACTION_OPEN,
				      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
				      GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
				      NULL);

	if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
	  {
		char *filename;
	
		filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
		fdes=fopen (filename,"r");  
		g_free (filename);
	  }
	
	gtk_widget_destroy (dialog);
	
// generate an event to refresh the info in the graphs
// fdclient is the file descriptor to access the packet procesor server

if (pass_data->open_param_window==FALSE)
   	{
	      	
	   pass_data->current_window= create_window3 (fdes,pass_data);
	   gtk_widget_show (pass_data->current_window);
	   sel_box1=lookup_widget(GTK_WIDGET(pass_data->main_window),"combobox1");
	   sel_box2=lookup_widget(GTK_WIDGET(pass_data->main_window),"combobox2");
	   sel1=gtk_combo_box_get_active(GTK_COMBO_BOX(sel_box1));
	   if(sel1!=-1)
			{
			pass_data->measure1=sel1;
			}
		else
			{
			pass_data->measure1=0;
			};
	   sel2=gtk_combo_box_get_active(GTK_COMBO_BOX(sel_box2));
	   if(sel2!=-1)
			{
			pass_data->measure2=sel2;
			}
		else
			{
			pass_data->measure2=0;
			};
	    lab1=lookup_widget(GTK_WIDGET(pass_data->current_window),"label1");
		lab2=lookup_widget(GTK_WIDGET(pass_data->current_window),"label2");
		lab3=lookup_widget(GTK_WIDGET(pass_data->current_window),"label_unit_1");
		lab4=lookup_widget(GTK_WIDGET(pass_data->current_window),"label_unit_2");				
		exit=lookup_widget(GTK_WIDGET(pass_data->current_window),"Exit");		
		gtk_label_set_text(GTK_LABEL(lab1),labels[pass_data->measure1]);
        gtk_label_set_text(GTK_LABEL(lab2),labels[pass_data->measure2]);
		gtk_label_set_text(GTK_LABEL(lab3),units[pass_data->measure1]);
        gtk_label_set_text(GTK_LABEL(lab4),units[pass_data->measure2]);	
	    load_graph(fdes,pass_data);
		pass_data->open_param_window=TRUE;			
		}
}
